From b455d0a0a176a747301060eebfa096d978b2c0ef Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 10 2020 06:58:38 +0000
Subject: [PATCH 241/2232] Merge pull request #95 from dtolnay/deref


Deref and DerefMut for UniquePtr
---

diff --git a/src/unique_ptr.rs b/src/unique_ptr.rs
index c8c5a67..b50e870 100644
--- a/src/unique_ptr.rs
+++ b/src/unique_ptr.rs
@@ -3,6 +3,7 @@ use std::ffi::c_void;
 use std::fmt::{self, Debug, Display};
 use std::marker::PhantomData;
 use std::mem;
+use std::ops::{Deref, DerefMut};
 use std::ptr;
 
 /// Binding to C++ `std::unique_ptr<T, std::default_delete<T>>`.
@@ -94,6 +95,32 @@ where
     }
 }
 
+impl<T> Deref for UniquePtr<T>
+where
+    T: UniquePtrTarget,
+{
+    type Target = T;
+
+    fn deref(&self) -> &Self::Target {
+        match self.as_ref() {
+            Some(target) => target,
+            None => panic!("called deref on a null UniquePtr<{}>", T::__NAME),
+        }
+    }
+}
+
+impl<T> DerefMut for UniquePtr<T>
+where
+    T: UniquePtrTarget,
+{
+    fn deref_mut(&mut self) -> &mut Self::Target {
+        match self.as_mut() {
+            Some(target) => target,
+            None => panic!("called deref_mut on a null UniquePtr<{}>", T::__NAME),
+        }
+    }
+}
+
 impl<T> Debug for UniquePtr<T>
 where
     T: Debug + UniquePtrTarget,
diff --git a/tests/unique_ptr.rs b/tests/unique_ptr.rs
new file mode 100644
index 0000000..e5eb66b
--- /dev/null
+++ b/tests/unique_ptr.rs
@@ -0,0 +1,8 @@
+use cxx::{CxxString, UniquePtr};
+
+#[test]
+#[should_panic = "called deref on a null UniquePtr<CxxString>"]
+fn test_deref_null() {
+    let unique_ptr = UniquePtr::<CxxString>::null();
+    let _: &CxxString = &unique_ptr;
+}

